`define mcleod_ideafix 1
//`define nandland 1


module MultiplesBCD_top

//definimos parametros globales de nuestros displays y nuestros numero binario en el caso de usar nandland
`ifdef nandland
  #(parameter INPUT_WIDTH=8,
    parameter DECIMAL_DIGITS=3
	)
`endif
(
//	input [3:0] hex_digit,
	output wire [6:0] seg_0,
	output wire [6:0] seg_1,
	output wire [6:0] seg_2,
	output wire [6:0] seg_3,
	output wire [6:0] seg_4,
	output wire [6:0] seg_5,
	output wire	[6:0] seg_6,
	output wire [6:0] seg_7,
	output reg [7:0] punto,
	//añadidos la entrada binaria

	input wire clk,
	input wire [7:0] n,
	input wire start,
	output wire [11:0]bcd,
	input wire finish
	);
	
	

	
// funcion equivalente descargada de 
// https://www.nandland.com/vhdl/modules/double-dabble.html	

`ifdef nandland
Binary_to_BCD calculobcd1 (

         .i_Clock(clk),
         .i_Binary(n),
			.i_Start(start),
			.o_BCD(bcd),
         .o_DV(finish)

);
`endif


// Módulo proporcionada por mcleod_ideafix

`ifdef mcleod_ideafix
 binary2bcd calculobcd1 (
    .clk(clk),
    .n(n),
    .start(start),
    .bcd(bcd),
    .finish(finish)
 	 );
`endif


//
//llamadas a modulos
//

llamardisplay display_00 (.binario(bcd[3:0]), .display(seg_0));
llamardisplay display_01 (.binario(bcd[7:4]), .display(seg_1));
llamardisplay display_02 (.binario(bcd[11:8]), .display(seg_2));
llamardisplay display_03 (.binario(0), .display(seg_3));
llamardisplay display_04 (.binario(0), .display(seg_4));
llamardisplay display_05 (.binario(0), .display(seg_5));
llamardisplay display_06 (.binario(n[3:0]), .display(seg_6));
llamardisplay display_07 (.binario(n[7:4]), .display(seg_7));
 
 
 
 always @(posedge clk)
 begin

	punto = ~8'b00000000; //apagamos todos los puntos de los BCD 

		 end 
endmodule 